

// THIS PROGRAM WAITS FOR A VOLUME UP COMMAND FROM THE REMOTE CONTROL USED WITH A TELEVISION.

// WHEN THIS COMMAND IS RECEIVED, A 36 - 40 KHz WAVE IS SENT OUT TO AND IR LED FOR APPROXIMATELY 15 SECONDS.

// THIS SWAMPS ANY INCOMING SIGNALS FROM THE REMOTE FOR THIS PERIOD.

// THEREFORE IT IS POSSIBLE TO JAM ANY UNWANTED COMMAND FROM THE REMOTE.

// IN THIS CASE, IT IS VOLUME UP.


// TCL REMOTE CODES AS BELOW.

// YELLOW BUTTON  = 9774845A  //RED BUTTON = 4ED5545A  //GREEN BUTTON = 2B77163A  // BLUE BUTTON = A084B2A2 // TEXT BUTTON = E6F5B7A2 // SUBTITLE = 9241DFDE // LIST = 45CBA93B 

// TV = CEBE3B7A  // INFO = E1B5A91A  // MUTE = 92DFD41F  // CHANNEL UP = 903E6B07  // CHANNEL DOWN = 71AEE7B6 // OPTION = 142CB0D6 // DOWN ARROW = BB8B3E9E  // RETURN = D4BE4E37 

// LEFT ARROW = 45481702 //OK = B8E7B4FE //  RIGHT ARROW = F0B4BB43 // MENU = CD9141E  //   UP ARROW = 1039789F  // EXIT = 7E940902 // ECO = 5C7759A // 0 = 898FDF7A  

// GUIDE = CE40C33E // 7 = F6317EDB //  8 = F9000E7E // 9 = C7291B77 // 4 = 450753D6 //  5 = BA0F4EDF  // 6 = 4AC4DA9A  // 1 = 6BC6597B  // 2 = 735B797E  // 3 = 1EC81DBF 

// SOURCE = 40C1789F //  POWER = 6A68351E





#include <IRremote.h>   // can be set to any pin


IRrecv irrecv(11);  //Input pin from IR reeceiver in this case Pin 11

int outPin = 8; // IR Output Led is connected to digital pin 8

long task = 0; // Register to count the number of times this task is performed. ( This is for the length of time the IR burst lasts for )

int check1=0;        //  check1 register.

int check2=1;       //  check2 register.

int combination=0; // combination register.


void setup() 
{
  Serial.begin(9600);
  
  pinMode(outPin, OUTPUT);    // sets the digital pin 8 as output.
  
  delay(1000);
  
  irrecv.enableIRIn();   //IR receiver
}

void loop() 

{
  combination=check1+check2;
  long task = 0; // Register to count the number of times this task is performed. ( This is for the length of time the IR burst lasts for )

  decode_results  results;        //struct for results of IR rx
  static unsigned long lastcode=0;
  unsigned long code;  
  if (irrecv.decode(&results)) {    //decode
    code=results.value;
    irrecv.resume();
    //Serial.println(code,HEX);
    // if(code==0xFFFFFFFF){code=lastcode;}   //emulate NEC repeat
    
    
    if((code==0x22D912BB)&&(combination <125))     // Volume UP button on my remote  ########################################## Change code here to suit your remote volume up button.

    {
      while (task < 400000) // Repeat this task 500000 times. This runs the wave form for about 15 seconds.

     {

       digitalWrite(outPin, HIGH); // sets the pin on                          ####### 10uS PRODUCES A 40KHz SQAURE WAVE FORM.
       delayMicroseconds(10);      // pauses for 14 microseconds               ####### 11uS PRODUCES A 37KHz SQAURE WAVE FORM
       digitalWrite(outPin, LOW);  // sets the pin off                         ####### 10uS HIGH and 11uS LOW Produces 38.5KHz
       delayMicroseconds(11);      // pauses for 14 microseconds
       task ++;                      // count the number of times through this loop
      }
    }


     if(code==0x9774845A)  // YELLOW BUTTON ON MY REMOTE ##############THIS BUTTON AND THE BUTTON BELOW DISABLE THE JAMMER (ONE MUST BE PRESSED THEN THE OTHER BUTTON ONE SECOND LATER)
     
    {
      check1=25;        //  Make check1 register 25.
      Serial.println(combination, 1);
    }

    if(code==0x4ED5545A)  // RED BUTTON ON MY REMOTE ###################THIS BUTTON AND THE BUTTON ABOVE DISABLE THE JAMMER
     
    {
      check2=100;        //  Make check2 register 100. When check 1 = 25 and check2 =100, this makes combination equal 125 which disables jammer to allow volume up.
    }

    
     // ANY OTHER CODE WILL RESET THE COMBINTATION REGISTER AND JAM THE VOLUME UP COMMAND ###### PASTE ALL THE OTHER BUTTON CODES FOR YOUR REMOTE HERE.
     if((code==0x2B77163A) ||(code==0xA084B2A2)||(code==0xE6F5B7A2)||(code==0x9241DFDE)||(code==0x45CBA93B )||(code==0xCEBE3B7A )||(code==0xE1B5A91A )||(code==0x92DFD41F )||(code==0x903E6B07 )|| (code==0x71AEE7B6)||(code==0x142CB0D6) || (code==0xBB8B3E9E)||(code==0xD4BE4E37)||(code==0x45481702)||(code==0xB8E7B4FE)||(code==0xF0B4BB43) ||(code==0xCD9141E)||(code==0x1039789F)||(code==0x7E940902)||(code==0x5C7759A)||(code==0x898FDF7A)||(code==0xCE40C33E)||(code==0xF6317EDB)||(code==0xF9000E7E)||(code==0xC7291B77)||(code==0x450753D6)||(code==0xBA0F4EDF)||(code==0x4AC4DA9A)||(code==0x6BC6597B)||(code==0x735B797E)||(code==0x1EC81DBF )||(code==0x40C1789F)||(code==0x6A68351E))
 

     { 
      check1=0;  // set both values to 0. This will now jam the signal.
      check2=0; 
     }

    combination=check1+check2;
    Serial.println(combination, 1); // Used for debugging 
    
    delay(1000); // 1 Second delay otherwise if button is held down on remote, the command will toggle at high speed.
         
      code=0;
      
  }

}
       

     
     
    
    



